/*
  CPP_CONTEST=2013
  CPP_PROBLEM=A
  CPP_LANG=C+OPENMP
  CPP_PROCESSES_PER_NODE=saturno 1
*/

/* RECORD
Juan Mompeán Esteban, Adrián Coca Lorente 
students of the University of Murcia, Spain
In the III Spanish Parallel Programming Contest
time 2665 msec
speed-up 10.81
*/ 

/*For each possition each thread evaluates if the
possition is assigned to it.
The partition is cyclic by rows.
If each thread treates only the data in 
the rows it has assigned, addition reduction of the execution
time could be obtained.*/

#include <stdlib.h>
#include <omp.h>
 
void accumulatelocal(int *a,int N,int v,int r1,int c1,int r2,int c2)
{
  int i,j;
  int *pos;
  for(i=r1;i<=r2;i+=1)
  {
	if ((i%omp_get_num_threads()) == omp_get_thread_num()) {
		pos=&a[i*N];
		for(j=c1;j<=c2;j++)
		{
		  pos[j]+=v;
		}
	}
  }
}
    
void  sec(int N,int M,int *a,int *value,int *r1,int *c1,int *r2,int *c2)
{
  int i;

#pragma omp parallel private(i)
{
  for(i=0;i<M;i++)
  {
     accumulatelocal(a,N,value[i],r1[i],c1[i],r2[i],c2[i]);
  }
}
}
